datablock ProjectileData(HL1MagnumProjectile : HL1BulletProjectile)
{
	directDamage        = $Pref::HL1Guns_DMGColt;
};
function HL1MagnumProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity)
{
	HL1BulletProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity);
}

datablock DebrisData(HL1MagnumShellDebris)
{
	shapeFile = "./shapes/python_shell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};
datablock ShapeBaseImageData(HL1MagnumFakeEject)
{
	shapeFile = "base/data/shapes/empty.dts";
	mountPoint = 0;
	offset = "-0.18957 0.3023 0.1549";
	
	casing = HL1MagnumShellDebris;
	shellExitDir        = "-0.1 -0.6 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 7.0;	
	shellVelocity       = 4.0;
	
	stateName[0]					= "Ready";
	stateTimeoutValue[0]			= 0.01;
	stateTransitionOnTimeout[0] 	= "EjectA";
	
	stateName[1]					= "EjectA";
	stateEjectShell[1]				= true;
	stateTimeoutValue[1]			= 0.01;
	stateTransitionOnTimeout[1] 	= "EjectB";
	
	stateName[2]					= "EjectB";
	stateEjectShell[2]				= true;
};
datablock PlayerData(emptyPlayer : playerStandardArmor)
{
	shapeFile = "base/data/shapes/empty.dts";
	boundingBox = "0.01 0.01 0.01";
	crouchboundingBox = "0.01 0.01 0.01";
	isEmptyPlayer = true;
	deathSound = "";
	painSound = "";
	useCustomPainEffects = true;
	mountSound = "";
	jumpSound = "";
	uiName = "";
};


datablock ItemData(HL1MagnumItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/coltpython.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "HL1 Revolver";
	iconName = "./icons/magnum";
	doColorShift = true;
	colorShiftColor = "0.45 0.45 0.45 1.000";

	 // Dynamic properties defined by the scripts
	image = HL1MagnumImage;
	canDrop = true;
	
	ghostToReload = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(HL1MagnumImage)
{
   // Basic Item properties
	shapeFile = "./shapes/coltpython.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = HL1MagnumItem;
   ammo = " ";
   projectile = HL1MagnumProjectile;
   projectileType = Projectile;

	casing = HL1MagnumShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = HL1MagnumItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.15;
	stateTransitionOnTimeout[0]       	= "ReadyA";
	stateSound[0]						= weaponSwitchSound;

	// 0-60
	stateName[1]                     	= "ReadyA";
	stateTransitionOnTriggerDown[1]  	= "FireA";
	stateTransitionOnNoAmmo[1]			= "ImageReload";
	stateAllowImageChange[1]         	= true;
	stateSequence[1]					= "ReadyA";
	
	stateName[2]                    	= "FireA";
	stateTransitionOnTimeout[2]     	= "SmokeA";
	stateTimeoutValue[2]            	= 0.5;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "FireA";
	stateScript[2]                  	= "onFire";
	stateWaitForTimeout[2]				= true;
	stateEmitter[2]						= HL1BulletFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateSound[2]						= HL1MagnumFireSound;
	stateEjectShell[2]       			= false;

	stateName[3] 						= "SmokeA";
	stateEmitter[3]						= HL1BulletSmokeEmitter;
	stateEmitterTime[3]					= 0.2;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]            	= 0.0;
	stateTransitionOnTimeout[3]     	= "WaitA";
	stateTransitionOnNoAmmo[3]			= "ImageReload";
	
	stateName[4]						= "WaitA";
	stateTransitionOnTriggerUp[4]		= "ReadyA"; // Set this to ReadyB to cycle through all states. Breaks reloading.
	
	// 60-120
	// stateName[5]                     	= "ReadyB";
	// stateTransitionOnTriggerDown[5]  	= "FireB";
	// stateTransitionOnNoAmmo[5]			= "ImageReload";
	// stateAllowImageChange[5]         	= true;
	// stateSequence[5]					= "ReadyB";
	
	// stateName[6]                    	= "FireB";
	// stateTransitionOnTimeout[6]     	= "SmokeB";
	// stateTimeoutValue[6]            	= 0.5;
	// stateFire[6]                    	= true;
	// stateAllowImageChange[6]        	= false;
	// stateSequence[6]                	= "FireB";
	// stateScript[6]                  	= "onFire";
	// stateWaitForTimeout[6]				= true;
	// stateEmitter[6]						= HL1BulletFlashEmitter;
	// stateEmitterTime[6]					= 0.05;
	// stateEmitterNode[6]					= "muzzleNode";
	// stateSound[6]						= HL1MagnumFireSound;
	// stateEjectShell[6]       			= true;

	// stateName[7] 						= "SmokeB";
	// stateEmitter[7]						= HL1BulletSmokeEmitter;
	// stateEmitterTime[7]					= 0.2;
	// stateEmitterNode[7]					= "muzzleNode";
	// stateTimeoutValue[7]            	= 0.0;
	// stateTransitionOnTimeout[7]     	= "WaitB";
	// stateTransitionOnNoAmmo[7]			= "ImageReload";
	
	// stateName[8]						= "WaitB";
	// stateTransitionOnTriggerUp[8]		= "ReadyC";
	
	// // 120-180
	// stateName[9]                     	= "ReadyC";
	// stateTransitionOnTriggerDown[9]  	= "FireC";
	// stateTransitionOnNoAmmo[9]			= "ImageReload";
	// stateAllowImageChange[9]         	= true;
	// stateSequence[9]					= "ReadyC";
	
	// stateName[10]                    	= "FireC";
	// stateTransitionOnTimeout[10]     	= "SmokeC";
	// stateTimeoutValue[10]            	= 0.5;
	// stateFire[10]                    	= true;
	// stateAllowImageChange[10]        	= false;
	// stateSequence[10]                	= "FireC";
	// stateScript[10]                  	= "onFire";
	// stateWaitForTimeout[10]				= true;
	// stateEmitter[10]					= HL1BulletFlashEmitter;
	// stateEmitterTime[10]				= 0.05;
	// stateEmitterNode[10]				= "muzzleNode";
	// stateSound[10]						= HL1MagnumFireSound;
	// stateEjectShell[10]       			= true;

	// stateName[11] 						= "SmokeC";
	// stateEmitter[11]					= HL1BulletSmokeEmitter;
	// stateEmitterTime[11]				= 0.2;
	// stateEmitterNode[11]				= "muzzleNode";
	// stateTimeoutValue[11]            	= 0.0;
	// stateTransitionOnTimeout[11]     	= "WaitC";
	// stateTransitionOnNoAmmo[11]			= "ImageReload";
	
	// stateName[12]						= "WaitC";
	// stateTransitionOnTriggerUp[12]		= "ReadyA";
	
	// Reload effects
	// Cyl Out
	stateName[13]						= "ImageReload";
	stateScript[13]						= "CylOut";
	stateSequence[13]					= "CylOut";
	stateTimeoutValue[13]				= 0.25;
	stateTransitionOnTimeout[13]		= "Unload";
	stateSound[13]						= brickRotateSound;
	stateAllowImageChange[13]        	= false;
	
	// Unload
	stateName[14]						= "Unload";
	stateScript[14]						= "UnLoad";
	stateSequence[14]					= "UnLoad";
	stateTimeoutValue[14]				= 0.1;
	stateTransitionOnTimeout[14]		= "Load";
	stateSound[14]						= brickPlantSound;	
	stateEjectShell[14]       			= false;
	stateAllowImageChange[14]        	= false;
	
	// Mag in
	stateName[15]						= "Load";
	stateScript[15]						= "Load";
	stateSequence[15]					= "Load";
	stateTimeoutValue[15]				= 1;
	stateTransitionOnTimeout[15]		= "CylIn";
	stateAllowImageChange[15]        	= false;
	
	// Chamber
	stateName[16]						= "CylIn";
	stateScript[16]						= "CylIn";
	stateSequence[16]					= "CylIn";
	stateTimeoutValue[16]				= 0.25;
	stateTransitionOnTimeout[16]		= "ReadyA";
	stateSound[16]						= brickRotateSound;
	stateAllowImageChange[16]        	= true;
};

function HL1MagnumImage::CylOut(%this, %player, %slot){%player.playThread(2, shiftLeft);}
function HL1MagnumImage::CylIn(%this, %player, %slot){%player.playThread(2, shiftRight);}
function HL1MagnumImage::Unload(%this, %player, %slot)
{
	%player.playThread(2, plant);

	//taken from Swollow's SWEP revolver code
	%a = new aiPlayer()
	{
		datablock = emptyPlayer;
		position = %player.getPosition();
		scale = "1 1 1";
	};
	%a.setDamageLevel(100);
	%player.mountObject(%a,0);
	%a.mountImage(HL1MagnumFakeEject,0);
	%a.mountImage(HL1MagnumFakeEject,1);
	%a.mountImage(HL1MagnumFakeEject,2);
	%a.schedule(100,delete);
	
	
	

}
function HL1MagnumImage::Load(%this, %player, %slot)
{
	%player.playThread(3, ShiftLeft);
	serverplay3d(brickPlantSound, %player.getHackPosition());
	
	for(%i = 1; %i < 6; %i++)
	{
		%player.schedule(160 * %i, playThread, 3, ShiftLeft);
		schedule(160 * %i, %player, serverplay3d, brickPlantSound, %player.getHackPosition());
	}
	
	%player.HL1357Rounds = 6;
	%player.setImageAmmo(0, 1);
}

function HL1MagnumImage::HandleReload(%this, %player, %slot)
{
	if(%player.HL1357Rounds >= 6 || %player.getImageState(0) !$= "ReadyA")
		return false;
	else
	{
		%player.setImageAmmo(0, 0);
		return true;
	}
}

function HL1MagnumImage::onFire(%this, %player, %slot)
{	
	if(%player.getDamagePercent() >= 1)
		return;
		
	%player.playThread(2, jump);
	%player.playThread(3, shiftAway);
	
	// small explanation of what i'm doing here
	// first we find what we're actually hitting, then we find a place that's right before we hit it on the same vector
	// and spawn the projectile there. projectile hits instantly, but we preserve all projectile functionality

	// the distance the projectile will instantly travel
	%flatness = 128;
	
	// how far backwards behind the target the projectile spawns
	%engageDistance = 1;
	
	// raycast
	%start = %player.getMuzzlePoint(%slot);
	%end = vectorScale(%player.getMuzzleVector(%slot), %flatness);
	%mask = $TypeMasks::PlayerObjectType | 
		$TypeMasks::VehicleObjectType | 
		$TypeMasks::fxBrickObjectType | 
		$TypeMasks::StaticObjectType | 
		$TypeMasks::InteriorObjectType | 
		$TypeMasks::TerrainObjectType | 
		$TypeMasks::ForceFieldObjectType;
	
	%target = containerRayCast(%start, vectorAdd(%start, %end), %mask);

	if(!%target)
	{
		%hitPosition = vectorAdd(%start, %end);
	}
	else
	{
		%hitPosition = getWords(%target, 1, 3);
	}
	
	%backwardsVelocity = vectorScale(%player.getMuzzleVector(%slot), -1);
	%backwardsPoint = vectorAdd(%hitPosition, vectorScale(%backwardsVelocity, %engageDistance));
	
	%projectile = %this.projectile;
	%spread = 0.0;
	%shellcount = 1;
	
	%client = %player.client;
	%pos = %player.getHackPosition();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %player.getMuzzleVector(%slot);
		%playerectVelocity = %player.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%playerectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);
		
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %backwardsPoint;
			sourceObject = %player;
			sourceSlot = %slot;
			client = %player.client;
		};
		MissionCleanup.add(%p);
		%dmg = 1 * $Pref::HalfLife1_DamageMult;
		%p.setScale(%dmg SPC %dmg SPC %dmg);
	}
	
	serverplay3d("HL1357Fire" @ getRandom(1, 2) @ "Sound", %pos SPC "0 0 0 0");
	
	%player.HL1357Rounds--;
	if(%player.HL1357Rounds <= 0)
	{
		%player.setImageAmmo(0, 0);
	}
	
	return %p;
}