datablock ExplosionData(HL1CrowbarExplosion : HL1BulletExplosion)
{
   //explosionShape = "";
	soundProfile = "";
	lifeTimeMS = 150;
	particleEmitter = HL1BulletExplosionEmitter;
	emitter[0] = "";
	shakeCamera = true;
	
	// Dynamic light
   lightStartRadius = 0;
   lightEndRadius = 0;
   lightStartColor = "0 0 0";
   lightEndColor = "0 0 0";
};
datablock ProjectileData(HL1CrowbarLightProjectile : HL1BulletProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";

	directDamage        = $Pref::HL1Guns_DMGCrowbar1;
	lifetime 			= 90;
	muzzleVelocity 		= 115;
	
	explosion           = HL1CrowbarExplosion;
};
datablock ProjectileData(HL1CrowbarHeavyProjectile : HL1CrowbarLightProjectile)
{
	projectileShapeName = "base/data/shapes/empty.dts";
	directDamage        = $Pref::HL1Guns_DMGCrowbar2;
	explosion           = HL1CrowbarExplosion;
	
	lifetime 			= 90;
	muzzleVelocity 		= 115;
};

function HL1CrowbarLightProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity)
{
	if(%col.getClassName() !$= "AIPlayer" && %col.getClassName() !$= "Player")
	{
		ServerPlay3D(HL1CrowbarHitSound, %pos);
	}
	else
	{
		ServerPlay3D("HL1CrowbarHitP" @ getRandom(1, 2) @ "Sound", %pos);
	}

	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity);
}
function HL1CrowbarHeavyProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity)
{
	HL1CrowbarLightProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity);
}


datablock ItemData(HL1CrowbarItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/crowbar.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "HL1 Crowbar";
	iconName = "./icons/crowbar";
	doColorShift = true;
	colorShiftColor = "0.35 0.35 0.35 1.000";

	 // Dynamic properties defined by the scripts
	image = HL1CrowbarImage;
	canDrop = true;
	
	ghostToReload = false;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(HL1CrowbarImage)
{
   // Basic Item properties
	shapeFile = "./shapes/crowbar.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = HL1CrowbarItem;
   ammo = " ";
   projectile = HL1BulletProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = HL1CrowbarItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.15;
	stateTransitionOnTimeout[0]       	= "Ready";
	stateSound[0]						= weaponSwitchSound;

	// Ready for input
	stateName[1]                     	= "Ready";
	stateTransitionOnTriggerDown[1]  	= "LightSwing";
	stateTransitionOnNotLoaded[1]		= "HeavySwing";
	stateAllowImageChange[1]         	= true;
	stateSequence[1]					= "Ready";
	
	// Fast swings
	stateName[2]						= "LightSwing";
	stateScript[2]						= "LightSwing";
	stateTransitionOnTimeout[2]			= "Ready";
	stateTimeoutValue[2]				= 0.250;
	stateSound[2]						= HL1CrowbarSwingSound;
	
	// Heavy Swing
	stateName[3]						= "HeavySwing";
	stateScript[3]						= "HeavySwing";
	stateTransitionOnTimeout[3]			= "WaitForTriggerUp";
	stateTimeoutValue[3]				= 0.50;
	stateSound[3]						= HL1CrowbarSwingSound;
	
	stateName[4]						= "WaitForTriggerUp";
	stateTransitionOnTriggerUp[4]		= "Ready";

};

function HL1CrowbarImage::LightSwing(%this, %player, %slot)
{
	%player.playThread(2, shiftDown);
	%projectile = HL1CrowbarLightProjectile;
	%spread = 0.00225;
	%shellcount = 1;

	
	%client = %player.client;
	%pos = %player.getHackPosition();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %player.getEyeVector();
		%playerectVelocity = %player.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%playerectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %player.getEyePoint();
			sourceObject = %player;
			sourceSlot = %slot;
			client = %player.client;
		};
		MissionCleanup.add(%p);
		%dmg = 1 * $Pref::HalfLife1_DamageMult;
		%p.setScale(%dmg SPC %dmg SPC %dmg);
	}
	
	return %p;
}

function HL1CrowbarImage::HeavySwing(%this, %player, %slot)
{
	%player.playThread(2, shiftUp);
	%player.schedule(100, playThread, 2, shiftDown);
	%projectile = HL1CrowbarHeavyProjectile;
	%spread = 0.00225;
	%shellcount = 1;

	
	%client = %player.client;
	%pos = %player.getHackPosition();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %player.getEyeVector();
		%playerectVelocity = %player.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%playerectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %player.getEyePoint();
			sourceObject = %player;
			sourceSlot = %slot;
			client = %player.client;
		};
		MissionCleanup.add(%p);
		%dmg = 1 * $Pref::HalfLife1_DamageMult;
		%p.setScale(%dmg SPC %dmg SPC %dmg);
	}
	
	return %p;
}