if($Pref::HalfLife1_DamageMult $= "")
	$Pref::HalfLife1_DamageMult = 1;

//Muzzle flash
datablock ParticleData(HL1BulletFlashParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 25;
	lifetimeVarianceMS   = 15;
	textureName          = "base/data/particles/star1";
	spinSpeed		= 1000.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "1.0 1.0 1.0 0.4";
	colors[1]     = "1.0 1.0 0.0 0.0";
	sizes[0]      = 0.5;
	sizes[1]      = 2.0;

	useInvAlpha = false;
};
datablock ParticleEmitterData(HL1BulletFlashEmitter)
{
   ejectionPeriodMS = 1;
   periodVarianceMS = 0;
   ejectionVelocity = 20.0;
   velocityVariance = 19.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HL1BulletFlashParticle";

   uiName = "HL1Bullet Flash";
};

// Smoke
datablock ParticleData(HL1BulletSmokeParticle)
{
	dragCoefficient      = 3;
	gravityCoefficient   = -0.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 1000;
	lifetimeVarianceMS   = 10;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.2 0.2 0.2 0.1";
	colors[1]     = "0.1 0.1 0.1 0.0";
	sizes[0]      = 0.15;
	sizes[1]      = 1.15;

	useInvAlpha = false;
};
datablock ParticleEmitterData(HL1BulletSmokeEmitter)
{
   ejectionPeriodMS = 6;
   periodVarianceMS = 0;
   ejectionVelocity = 1.0;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HL1BulletSmokeParticle";

   uiName = "HL1Bullet Smoke";
};

//// Hit
// Hit dust effect
datablock ParticleData(HL1BulletExplosionParticle)
{
	dragCoefficient      = 16;
	gravityCoefficient   = 0;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 100;
	lifetimeVarianceMS   = 50;
	textureName          = "base/data/particles/cloud";
	spinSpeed		= 10.0;
	spinRandomMin		= -50.0;
	spinRandomMax		= 50.0;
	colors[0]     = "0.3 0.3 0.3 0.2";
	colors[1]     = "1 1 1 0.0";
	sizes[0]      = 0.95;
	sizes[1]      = 0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(HL1BulletExplosionEmitter)
{
   ejectionPeriodMS = 16;
   periodVarianceMS = 0;
   ejectionVelocity = 20;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 89;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HL1BulletExplosionParticle";

   useEmitterColors = true;
   uiName = "HL1Bullet Hit Dust";
};

// Hit flash effect, star
datablock ParticleData(HL1BulletExplosionRingParticle)
{
	dragCoefficient      = 0;
	gravityCoefficient   = 3.5;
	inheritedVelFactor   = 0.2;
	constantAcceleration = 0.0;
	lifetimeMS           = 500;
	lifetimeVarianceMS   = 35;
	textureName          = "base/data/particles/chunk";
	spinSpeed		= 500.0;
	spinRandomMin		= -500.0;
	spinRandomMax		= 500.0;
	colors[0]     = "0.3 0.3 0.3 0.5";
	colors[1]     = "0.0 0.0 0.0 0.5";
	sizes[0]      = 0.3;
	sizes[1]      = 0;

	useInvAlpha = true;
};
datablock ParticleEmitterData(HL1BulletExplosionRingEmitter)
{
	lifeTimeMS = 00;

   ejectionPeriodMS = 8;
   periodVarianceMS = 0;
   ejectionVelocity = 10;
   velocityVariance = 0.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 90;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "HL1BulletExplosionRingParticle";

   useEmitterColors = true;
   uiName = "HL1Bullet Hit Flash";
};

//shell
datablock DebrisData(HL1ShotgunShellDebris)
{
	shapeFile = "./shapes/sgunshell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;
	
	particleEmitter = HL1BulletSmokeEmitter;

	gravModifier = 2;
};

// Hit explosion data
datablock ExplosionData(HL1BulletExplosion)
{
   //explosionShape = "";
	soundProfile = bulletHitSound;

   lifeTimeMS = 150;

   particleEmitter = HL1BulletExplosionEmitter;
   particleDensity = 15;
   particleRadius = 0.05;

   emitter[0] = HL1BulletExplosionRingEmitter;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = false;
   camShakeFreq = "10.0 11.0 10.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 2;
   lightEndRadius = 2;
   lightStartColor = "0.5 0.8 0.9";
   lightEndColor = "0 0 0";
};

/// Projectile
datablock ProjectileData(HL1BulletProjectile)
{
   projectileShapeName = "Add-Ons/Weapon_Gun/bullet.dts";
   directDamage        = $Pref::HL1Guns_DMGBullet;
   //directDamageType    = $DamageType::Gun;
   //radiusDamageType    = $DamageType::Gun;

   brickExplosionRadius = 0;
   brickExplosionImpact = true;          //destroy a brick if we hit it directly?
   brickExplosionForce  = 10;
   brickExplosionMaxVolume = 1;          //max volume of bricks that we can destroy
   brickExplosionMaxVolumeFloating = 2;  //max volume of bricks that we can destroy if they aren't connected to the ground

   impactImpulse	     = 400;
   verticalImpulse	  = 400;
   explosion           = $Pref::HL1Guns_HitEffect;
   particleEmitter     = ""; //bulletTrailEmitter;

   muzzleVelocity      = 200;
   velInheritFactor    = 0;

   armingDelay         = 00;
   lifetime            = 4000;
   fadeDelay           = 3500;
   bounceElasticity    = 0.5;
   bounceFriction      = 0.20;
   isBallistic         = true;
   gravityMod 		   = 0.2;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "HL1 Bullet";
};

// Ricochet function
function getBounceVector(%vector, %normal)
{
	%v = %vector;
	%n = %normal;
	return vectorSub(%v, vectorScale(%n, 2 * vectorDot(%v, %n)));
}
function HL1BulletProjectile::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity)
{
	Parent::onCollision(%this, %obj, %col, %fade, %pos, %normal, %velocity);
	
	%reflectVec = getBounceVector(%velocity, %normal);
	%dot = vectorDot(%velocity, %reflectVec);
	%dot = %dot / (vectorLen(%velocity) * vectorLen(%reflectVec));
	%acos = mACos(%dot);
	%angle = mRadtoDeg(%acos);
	
	//// vars
	%ricoMinimumAngle = 40; 	// minimum angle that can ricochet
	%ricoChanceCurve = 5; 		// the higher, the more common ricochet is
	%ricoMinimumFactor = 0.4; 	// minimum speed of a rico'd bullet
	%ricoRarity = 3;			// higher = less common rico
	
	if(%angle > %ricoMinimumAngle)
		return;
	
	%chanceMax = mCeil(%angle / %ricoChanceCurve) + %ricoRarity; // rico occurs very often at obtuse angles, and almost never towards right angle. minimum %50 chance at any angle
	%chance = getRandom(0, %chanceMax);
	
	if(!%chance)
	{
		%bounceFac = getRandom();
		if(%bounceFac < %ricoMinimumFactor)
			%bounceFac = %ricoMinimumFactor;
		
		//// sound
		serverplay3d("HL1Ric" @ getRandom(1, 2) @ "Sound", %obj.getPosition() SPC "0 0 0 0");
		
		%obj.bounce(%bounceFac, %client);
	}
}