datablock ItemData(HL1PistolItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/glock4_3.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "HL1 Pistol";
	iconName = "./icons/pistol";
	doColorShift = true;
	colorShiftColor = "0.35 0.35 0.35 1.000";

	 // Dynamic properties defined by the scripts
	image = HL1PistolImage;
	canDrop = true;
	
	ghostToReload = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(HL1PistolImage)
{
   // Basic Item properties
	shapeFile = "./shapes/glock4_3.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = HL1PistolItem;
   ammo = " ";
   projectile = HL1BulletProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = HL1PistolItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.15;
	stateTransitionOnTimeout[0]       	= "Ready";
	stateSound[0]						= weaponSwitchSound;

	// Ready for input
	stateName[1]                     	= "Ready";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateTransitionOnNotLoaded[1]		= "RapidFire";
	stateTransitionOnNoAmmo[1]			= "ImageReload";
	stateAllowImageChange[1]         	= true;
	stateSequence[1]					= "Ready";

	// Rapid fire
	stateName[6]                    	= "RapidFire";
	stateTransitionOnTimeout[6]     	= "Smoke";
	stateTimeoutValue[6]            	= 0.2; // 300 RPM //0.08;
	stateFire[6]                    	= true;
	stateAllowImageChange[6]        	= false;
	stateSequence[6]                	= "Fire";
	stateScript[6]                  	= "onRapidFire";
	stateWaitForTimeout[6]				= true;
	stateEmitter[6]						= HL1BulletFlashEmitter;
	stateEmitterTime[6]					= 0.05;
	stateEmitterNode[6]					= "muzzleNode";
	stateSound[6]						= HL1PistolFireSound;
	stateEjectShell[6]       			= true;
	
	// Normal fire
	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.333; // 200RPM //0.10;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "Fire";
	stateScript[2]                  	= "onFire";
	stateWaitForTimeout[2]				= true;
	stateEmitter[2]						= HL1BulletFlashEmitter;
	stateEmitterTime[2]					= 0.05;
	stateEmitterNode[2]					= "muzzleNode";
	stateSound[2]						= HL1PistolFireSound;
	stateEjectShell[2]       			= true;

	// Smoke and wait
	stateName[3] 						= "Smoke";
	stateEmitter[3]						= HL1BulletSmokeEmitter;
	stateEmitterTime[3]					= 0.2;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]            	= 0.01;
	stateTransitionOnTriggerUp[3]     	= "Ready";
	stateTransitionOnNoAmmo[3]			= "ImageReload";
	
	// Reload effects
	// Mag out
	stateName[11]						= "ImageReload";
	stateScript[11]						= "IRMagout";
	stateTimeoutValue[11]				= 0.5;
	stateTransitionOnTimeout[11]		= "IR-Magin";
	stateSound[11]						= brickMoveSound;
	
	// Mag in
	stateName[12]						= "IR-Magin";
	stateScript[12]						= "IRMagin";
	stateTimeoutValue[12]				= 0.5;
	stateTransitionOnTimeout[12]		= "IR-Chamber";
	stateSound[12]						= brickMoveSound;
	
	// Chamber
	stateName[13]						= "IR-Chamber";
	stateScript[13]						= "IRChamber";
	stateTimeoutValue[13]				= 0.5;
	stateSequence[13]					= "Fire";
	stateTransitionOnTimeout[13]		= "Ready";
	stateSound[13]						= brickPlantSound;
};

function HL1PistolImage::IRMagout(%this, %player, %slot)
{
	%player.playThread(2, shiftTo);
}
function HL1PistolImage::IRMagin(%this, %player, %slot)
{
	%player.playThread(2, shiftAway);
}
function HL1PistolImage::IRChamber(%this, %player, %slot)
{
	%player.HL1PistolRounds = 18;
	%player.playThread(2, plant);
	%player.setImageAmmo(0, 1);
}

function HL1PistolImage::onMount(%this, %player, %slot)
{
	Parent::onMount(%this, %player, %slot);
	if(%player.HL1PistolRounds <= 0)
	{
		%player.setImageAmmo(0, 0);
	}
}

function HL1PistolImage::onFire(%this, %player, %slot)
{	

	%projectile = %this.projectile;
	%spread = 0.0002;
	%shellcount = 1;
	
	%client = %player.client;
	%pos = %player.getHackPosition();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %player.getMuzzleVector(%slot);
		%playerectVelocity = %player.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%playerectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %player.getMuzzlePoint(%slot);
			sourceObject = %player;
			sourceSlot = %slot;
			client = %player.client;
		};
		MissionCleanup.add(%p);
		%dmg = 1 * $Pref::HalfLife1_DamageMult;
		%p.setScale(%dmg SPC %dmg SPC %dmg);
	}
	
	%player.HL1PistolRounds--;
	
	if(%player.HL1PistolRounds <= 0)
	{
		%player.setImageAmmo(0, 0);
	}
	
	return %p;
}

function HL1PistolImage::onRapidFire(%this, %player, %slot)
{	
	%projectile = %this.projectile;
	%spread = 0.00225;
	%shellcount = 1;
	
	if(%player.HL1PistolRounds <= 0)
	{
		%shellcount = 0;
	}

	
	%client = %player.client;
	%pos = %player.getHackPosition();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %player.getMuzzleVector(%slot);
		%playerectVelocity = %player.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%playerectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %player.getMuzzlePoint(%slot);
			sourceObject = %player;
			sourceSlot = %slot;
			client = %player.client;
		};
		MissionCleanup.add(%p);
		%dmg = 1 * $Pref::HalfLife1_DamageMult;
		%p.setScale(%dmg SPC %dmg SPC %dmg);
	}
	
	%player.HL1PistolRounds--;
	
	if(%player.HL1PistolRounds <= 0)
	{
		%player.setImageAmmo(0, 0);
	}
	
	return %p;
}

function HL1PistolImage::HandleReload(%this, %player, %slot)
{
	if(%player.HL1PistolRounds >= 18 || %player.getImageState(0) !$= "Ready")
		return false;
	else
	{
		%player.setImageAmmo(0, 0);
		return true;
	}
}