datablock ItemData(HL1MP5Item)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/MP5.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "HL1 SMG";
	iconName = "./icons/smg";
	doColorShift = true;
	colorShiftColor = "0.35 0.35 0.35 1.000";

	 // Dynamic properties defined by the scripts
	image = HL1MP5Image;
	canDrop = true;
	
	ghostToReload = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(HL1MP5Image)
{
   // Basic Item properties
	shapeFile = "./shapes/MP5.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = HL1MP5Item;
   ammo = " ";
   projectile = HL1BulletProjectile;
   projectileType = Projectile;

	casing = gunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = HL1MP5Item.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.15;
	stateTransitionOnTimeout[0]       	= "Ready";
	stateSound[0]						= weaponSwitchSound;

	// Ready for input.
	// Trigger down will take us to fire.
	// Not loaded calls the alt-fire. Alt-fire condition is done in package.cs
	// No ammo calls for reload.
	stateName[1]                     	= "Ready";
	stateTransitionOnTriggerDown[1]  	= "RapidFire";
	stateTransitionOnNotLoaded[1]		= "LaunchGrenade";
	stateTransitionOnNoAmmo[1]			= "Reload";
	stateAllowImageChange[1]         	= true;
	stateSequence[1]					= "Ready";

	// Rapid fire
	stateName[6]                    	= "RapidFire";
	stateTransitionOnTimeout[6]     	= "Smoke";
	stateTimeoutValue[6]            	= 0.1; //600rpm
	stateFire[6]                    	= true;
	stateAllowImageChange[6]        	= false;
	stateSequence[6]                	= "Fire";
	stateScript[6]                  	= "onFire";
	stateWaitForTimeout[6]				= true;
	stateEmitter[6]						= HL1BulletFlashEmitter;
	stateEmitterTime[6]					= 0.05;
	stateEmitterNode[6]					= "muzzleNode";
	stateEjectShell[6]       			= true;
	
	// Launch Grenade
	stateName[2]                    	= "LaunchGrenade";
	stateTransitionOnTimeout[2]     	= "Ready";
	stateTimeoutValue[2]            	= 0.50;
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "";
	stateScript[2]                  	= "onLaunchGrenade";
	stateWaitForTimeout[2]				= true;
	stateEjectShell[2]       			= false;

	// Smoke
	// In the fire script we already figure out whether or not there's more ammo in the mag.
	// So we can call reloading here instead of beforehand.
	stateName[3] 						= "Smoke";
	stateEmitter[3]						= HL1BulletSmokeEmitter;
	stateEmitterTime[3]					= 0.2;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]            	= 0.0;
	stateTransitionOnTimeout[3]     	= "Ready";
	stateTransitionOnNoAmmo[3]			= "Reload";

	// Image reload
	stateName[4]						= "Reload";
	stateSequence[4]					= "IR_BoltBack";
	stateScript[4]						= "IR_BoltBack";
	stateTransitionOnTimeout[4]			= "IR_MagOut";
	stateTimeoutValue[4]				= 0.5;
	stateSound[4]						= brickRotateSound;
	
	stateName[5]						= "IR_MagOut";
	stateSequence[5]					= "MagOut";
	stateScript[5]						= "IR_MagOut";
	stateTransitionOnTimeout[5]			= "IR_MagIn";
	stateTimeoutValue[5]				= 0.5;
	stateSound[5]						= brickMoveSound;
	
	stateName[7]						= "IR_MagIn";
	stateSequence[7]					= "MagIn";
	stateScript[7]						= "IR_MagIn";
	stateTransitionOnTimeout[7]			= "IR_BoltForward";
	stateTimeoutValue[7]				= 0.5;
	stateSound[7]						= brickMoveSound;
	
	stateName[8]						= "IR_BoltForward";
	stateSequence[8]					= "IR_BoltForward";
	stateScript[8]						= "IR_BoltForward";
	stateTransitionOnTimeout[8]			= "Ready";
	stateTimeoutValue[8]				= 0.5;
	stateSound[8]						= brickPlantSound;


};

// Reload functions. Most of these just play animations
function HL1MP5Image::IR_BoltBack(%this, %player, %slot) { %player.playThread(2, plant); %player.playThread(3, shiftRight);}
function HL1MP5Image::IR_MagOut(%this, %player, %slot) { %player.playThread(2, shiftLeft); %player.playThread(2, plant);}
function HL1MP5Image::IR_MagIn(%this, %player, %slot) { %player.playThread(2, shiftRight); %player.playThread(3, plant);}
function HL1MP5Image::IR_BoltForward(%this, %player, %slot) 
{ 
	%player.playThread(2, plant); 
	%player.playThread(3, shiftLeft); 
	
	// Need to make sure that ammo is set back up, and that imageAmmo is set to true
	// Or we will go into an infinite loop of reloading.
	%player.HL1MP5Rounds = 50;
	%player.setImageAmmo(0, 1);
}

function HL1MP5Image::onMount(%this, %player, %slot)
{
	// On mount, imageAmmo is set to true automatically. We need an additional check
	// to make sure that this is set according to the amount of ammo in the mag,
	// preventing the player from switching away during a reload, interrupting the
	// reload, switching back, and being allowed to fire a free round.
	
	Parent::onMount(%this, %player, %slot);
	if(%player.HL1MP5Rounds <= 0)
	{
		%player.setImageAmmo(0, 0);
	}
}

function HL1MP5Image::onFire(%this, %player, %slot)
{
	%projectile = %this.projectile;
	%spread = 0.0002;
	%shellcount = 1;
	
	%client = %player.client;
	%pos = %player.getHackPosition();
	%muzPos = %player.getMuzzlePoint(%slot);

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %player.getMuzzleVector(%slot);
		%playerectVelocity = %player.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%playerectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %muzPos;
			sourceObject = %player;
			sourceSlot = %slot;
			client = %player.client;
		};
		MissionCleanup.add(%p);
		%dmg = $Pref::HL1Guns_ScaleDMGMP5;
		%p.setScale(%dmg SPC %dmg SPC %dmg);
	}
	
	serverplay3d("HL1MP5Fire" @ getRandom(1, 2) @ "Sound", %muzPos SPC "0 0 0 0");
		
	// Ammo is handled AFTER the shot is fired, so we don't have to spend precious timeout time and state
	// trying to figure out how much ammo we have. This way, if we shoot our last shot, we just tell the 
	// game we're empty, and it can be handled in the smoke or ready state instead of several states
	// leading up to fire.
	%player.HL1MP5Rounds--;
	if(%player.HL1MP5Rounds <= 0)
	{
		%player.setImageAmmo(0, 0);
	}
	return %p;
}

function HL1MP5Image::onLaunchGrenade(%this, %player, %slot)
{

	%player.playThread(2, plant);

	// Allow the player to dry-fire the alternate fire. This way, we don't need to
	// use extra states to determine if we can alt-fire. Create sounds in the script
	// instead of in the state system.
	if(getSimTime() - %player.lastHL1GLShot < 5000)
		return;
	%player.lastHL1GLShot = getSimTime();

	%player.playThread(2, plant);

	%projectile = $Pref::HL1Guns_MP5GrenadeData;
	%spread = 0.0002;
	%shellcount = 1;
	
	%initPosition = setWord(%player.getMuzzlePoint(%slot), 2, (getWord(%player.getMuzzlePoint(%slot), 2) - 0.4));
	
	%client = %player.client;
	%pos = %player.getHackPosition();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %player.getMuzzleVector(%slot);
		%playerectVelocity = %player.getVelocity();
		%vector1 = VectorScale(%vector, (%projectile.muzzleVelocity / 2.5));
		%vector2 = VectorScale(%playerectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %initPosition;
			sourceObject = %player;
			sourceSlot = %slot;
			client = %player.client;
		};
		MissionCleanup.add(%p);
		%dmg = $Pref::HL1Guns_MP5GrenadeScale;
		%p.setScale(%dmg SPC %dmg SPC %dmg);
	}
	
	serverplay3d("HL1GLaunchFireSound", %pos SPC "0 0 0 0");
	
	return %p;
}

function HL1MP5Image::HandleReload(%this, %player, %slot)
{
	if(%player.HL1MP5Rounds >= 50 || %player.getImageState(0) !$= "Ready")
		return false;
	else
	{
		%player.setImageAmmo(0, 0);
		return true;
	}
}