datablock ItemData(HL1ShotgunItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./shapes/spas12.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "HL1 Shotgun";
	iconName = "./icons/shotgun";
	doColorShift = true;
	colorShiftColor = "0.35 0.35 0.35 1.000";

	 // Dynamic properties defined by the scripts
	image = HL1ShotgunImage;
	canDrop = true;
	
	ghostToReload = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(HL1ShotgunImage)
{
   // Basic Item properties
	shapeFile = "./shapes/spas12.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";
   eyeOffset = 0; //"0.7 1.2 -0.5";
   rotation = eulerToMatrix( "0 0 0" );

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = true;

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = HL1ShotgunItem;
   ammo = " ";
   projectile = HL1BulletProjectile;
   projectileType = Projectile;

	casing = HL1ShotgunShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

   //melee particles shoot from eye node for consistancy
   melee = false;
   //raise your arm up or not
   armReady = true;

   doColorShift = true;
   colorShiftColor = HL1ShotgunItem.colorShiftColor;//"0.400 0.196 0 1.000";

   //casing = " ";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     	= "Activate";
	stateTimeoutValue[0]             	= 0.15;
	stateTransitionOnTimeout[0]       	= "Ready";
	stateSound[0]						= weaponSwitchSound;

	// Ready for input
	stateName[1]                     	= "Ready";
	stateTransitionOnTriggerDown[1]  	= "Fire";
	stateTransitionOnNotLoaded[1]		= "DFire";
	stateTransitionOnNoAmmo[1]			= "ForceReload";
	stateAllowImageChange[1]         	= true;
	stateSequence[1]					= "Ready";

	// Rapid fire
	stateName[6]                    	= "DFire";
	stateTransitionOnTimeout[6]     	= "Smoke";
	stateTimeoutValue[6]            	= 1.0; // + 0.5 = 40RPM
	stateFire[6]                    	= true;
	stateAllowImageChange[6]        	= false;
	stateSequence[6]                	= "Fire";
	stateScript[6]                  	= "onDFire";
	stateWaitForTimeout[6]				= true;
	stateEmitter[6]						= HL1BulletFlashEmitter;
	stateEmitterTime[6]					= 0.1;
	stateEmitterNode[6]					= "muzzleNode";
	stateSound[6]						= HL1ShotgunDFireSound;
	
	// Normal fire
	stateName[2]                    	= "Fire";
	stateTransitionOnTimeout[2]     	= "Smoke";
	stateTimeoutValue[2]            	= 0.250; // + 0.5 = 80RPM
	stateFire[2]                    	= true;
	stateAllowImageChange[2]        	= false;
	stateSequence[2]                	= "Fire";
	stateScript[2]                  	= "onFire";
	stateWaitForTimeout[2]				= true;
	stateEmitter[2]						= HL1BulletFlashEmitter;
	stateEmitterTime[2]					= 0.1;
	stateEmitterNode[2]					= "muzzleNode";
	stateSound[2]						= HL1ShotgunSFireSound;


	// Smoke and wait
	stateName[3] 						= "Smoke";
	stateSequence[3]					= "Charge";
	stateScript[3]						= "ChargeScript";
	stateSound[3]						= HL1ShotgunChargeSound;
	stateEmitter[3]						= HL1BulletSmokeEmitter;
	stateEmitterTime[3]					= 0.2;
	stateEmitterNode[3]					= "muzzleNode";
	stateTimeoutValue[3]            	= 0.5;
	stateTransitionOnTimeout[3]     	= "No_Slam";
	stateTransitionOnNoAmmo[3]			= "ImageReload";
	stateWaitForTimeout					= true;
	stateEjectShell[3]       			= true;
	
	// wait for triggerup
	stateName[18]						= "No_Slam";
	stateTransitionOnTriggerUp[18]		= "Ready";
	
	// Reload effects
	// Put one round in the chamber
	stateName[11]						= "ImageReload";
	stateScript[11]						= "LoadOne";
	stateTimeoutValue[11]				= 0.5;
	stateTransitionOnTimeout[11]		= "CheckFull_Exec";
	
	// Check if the mag is full. If not, go to the input stage.
	// If full, charge and ready.
	
	stateName[13]						= "CheckFull_Exec";
	stateTransitionOnNotLoaded[13]		= "Load_Input";
	stateTransitionOnLoaded[13]			= "End_Reload";
	
	stateName[14]						= "Load_Input";
	stateTransitionOnTriggerDown[14]	= "End_Reload";
	stateTransitionOnTriggerUp[14]		= "ImageReload";
	
	stateName[15]						= "End_Reload";
	stateSequence[15]					= "Charge";
	stateScript[15]						= "EndReload";
	stateTimeoutValue[15]				= 0.5;
	stateTransitionOnTimeout[15]		= "No_Slam";
	stateSound[15]						= HL1ShotgunChargeSound;
	
	// Force reload. Make sure we're not full and then go to reload
	stateName[16]						= "ForceReload";
	stateTimeoutValue[16]				= 0.1;
	stateTransitionOnTimeout[16]		= "ForceReloadB";
	
	stateName[17]						= "ForceReloadB";
	stateScript[17]						= "ForceReload";
	stateTimeoutValue[17]				= 0.1;
	stateTransitionOnTimeout[17]		= "CheckFull_Exec";
	
};

function HL1ShotgunImage::ChargeScript(%this, %player, %slot)
{
	%player.playThread(2, plant);
}

function HL1ShotgunImage::EndReload(%this, %player, %slot)
{
	%player.playThread(2, plant);
	%player.setImageAmmo(0, 1);
	%player.setImageLoaded(0, 1);
}

function HL1ShotgunImage::ForceReload(%this, %player, %slot)
{
	%player.playThread(2, plant);
	%player.setImageLoaded(0, 1);
	
	if(%player.HL1ShotgunRounds >= 8)
		%player.setImageLoaded(0, 1);
	else
		%player.setImageLoaded(0, 0);
}

function HL1ShotgunImage::LoadOne(%this, %player, %slot)
{
	%player.HL1ShotgunRounds++;
	%player.playThread(2, shiftLeft);
	%player.setImageAmmo(0, 1);
	
	if(%player.HL1ShotgunRounds >= 8)
		%player.setImageLoaded(0, 1);
	else
		%player.setImageLoaded(0, 0);
		
	serverplay3d("HL1ShotgunLoad" @ getRandom(1, 2) @ "Sound", %player.getHackPosition() SPC "0 0 0 0");
}

function HL1ShotgunImage::onMount(%this, %player, %slot)
{
	Parent::onMount(%this, %player, %slot);
	if(%player.HL1ShotgunRounds <= 0)
	{
		%player.setImageAmmo(0, 0);
	}
}

function HL1ShotgunImage::onFire(%this, %player, %slot)
{	

	%player.playThread(2, jump);

	%projectile = %this.projectile;
	%spread = 0.004;
	%shellcount = $Pref::HL1Guns_ShotgunPellets1;
	
	%client = %player.client;
	%pos = %player.getHackPosition();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %player.getMuzzleVector(%slot);
		%playerectVelocity = %player.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%playerectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %player.getMuzzlePoint(%slot);
			sourceObject = %player;
			sourceSlot = %slot;
			client = %player.client;
		};
		MissionCleanup.add(%p);
		%dmg = 0.625 * $Pref::HalfLife1_DamageMult;
		%p.setScale(%dmg SPC %dmg SPC %dmg);
	}
	
	%player.HL1ShotgunRounds--;
	if(%player.HL1ShotgunRounds <= 0)
	{
		%player.setImageAmmo(0, 0);
	}
	
	// Blowback
	%recVel = vectorScale(vectorScale(%velocity, -1), 0.02);
	%player.addVelocity(%recVel);
	
	return %p;
}

function HL1ShotgunImage::onDFire(%this, %player, %slot)
{	
	%player.playThread(2, shiftAway);

	%projectile = %this.projectile;
	%spread = 0.008;
	%shellcount = $Pref::HL1Guns_ShotgunPellets2;
	
	if(%player.HL1ShotgunRounds <= 0)
	{
		%shellcount = 0;
	}

	
	%client = %player.client;
	%pos = %player.getHackPosition();

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %player.getMuzzleVector(%slot);
		%playerectVelocity = %player.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%playerectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %player.getMuzzlePoint(%slot);
			sourceObject = %player;
			sourceSlot = %slot;
			client = %player.client;
		};
		MissionCleanup.add(%p);
		%dmg = $Pref::HL1Guns_ScaleDMGShotgun;
		%p.setScale(%dmg SPC %dmg SPC %dmg);
	}
	
	%player.HL1ShotgunRounds -= 2;
	if(%player.HL1ShotgunRounds <= 0)
	{
		%player.setImageAmmo(0, 0);
	}
	
	// Blowback
	%recVel = vectorScale(vectorScale(%velocity, -1), 0.03);
	%player.addVelocity(%recVel);
	
	return %p;
}

function HL1ShotgunImage::HandleReload(%this, %player, %slot)
{
	if(%player.HL1ShotgunRounds >= 8 || %player.getImageState(0) !$= "Ready")
		return false;
	else
	{
		%player.setImageAmmo(0, 0);
		return true;
	}
}